	case BMP_SYSTEM_MESSAGE_UI_START:
		{
		    static bool running = false;

		    GdkDisplay *display;

		    if (!running)
		    {
		      gtk_init (0, NULL);
		      Gdk::wrap_init();
		      Gtk::wrap_init(); 
		      running = true;
		    }

		    if (message->data)
		      {
			display = gdk_display_open ((gchar*)message->data);
			if (display)
			  {
			    gdk_display_manager_set_default_display (gdk_display_manager_get (), display);
			  }
			else
			  gdk_display_open_default_libgtk_only();
		      }
		    else
			gdk_display_open_default_libgtk_only();

		    g_log (G_LOG_DOMAIN, G_LOG_LEVEL_INFO, "Starting UI");

		    Bmp::shell_init (); 
		    g_signal_emit (G_OBJECT (control),
		      signals[BMP_SYSTEM_CONTROL_SIGNAL_SET_PLAYSTATUS],
		      0, play->property_status().get_value());
		    bmp_system_control_update_title (control);

		}
	    break;

	case BMP_SYSTEM_MESSAGE_UI_STOP:
		{
		    Bmp::shell_stop ();
		}
	    break;

